from .FigurateNum import FigurateNum

from .plane_figuratenum import (
    polygonal_numbers, centered_square_numbers, diamond_numbers,
    centered_dodecagonal_numbers, star_numbers, centered_mgonal_numbers,
    pronic_numbers, heteromecic_numbers, oblong_numbers,  polite_numbers,
    impolite_numbers, cross_numbers, aztec_diamond_numbers, polygram_numbers,
    centered_star_polygonal_numbers, pentagram_numbers, gnomic_numbers,
    truncated_triangular_numbers, truncated_square_numbers, truncated_pronic_numbers,
    truncated_centered_pol_numbers, truncated_centered_mgonal_numbers,
    truncated_centered_hexagonal_numbers, truncated_hex_numbers,
    generalized_mgonal_numbers, generalized_centered_pol_numbers, generalized_pronic_numbers
)

from .specific_plane_figuratenum import (
    triangular_numbers, square_numbers, pentagonal_numbers,
    hexagonal_numbers, heptagonal_numbers, octagonal_numbers,
    nonagonal_numbers, decagonal_numbers, hendecagonal_numbers,
    dodecagonal_numbers, tridecagonal_numbers, tetradecagonal_numbers,
    pentadecagonal_numbers, hexadecagonal_numbers, heptadecagonal_numbers,
    octadecagonal_numbers, nonadecagonal_numbers, icosagonal_numbers,
    icosihenagonal_numbers, icosiheptagonal_numbers, icosidigonal_numbers,
    icositrigonal_numbers, icositetragonal_numbers, icosipentagonal_numbers,
    icosihexagonal_numbers, centered_icosiheptagonal_numbers, icosioctagonal_numbers,
    icosinonagonal_numbers, triacontagonal_numbers
)

from .space_figuratenum import (
    m_pyramidal_numbers, cubic_numbers, tetrahedral_numbers,
    octahedral_numbers, dodecahedral_numbers, icosahedral_numbers,
    truncated_tetrahedral_numbers, truncated_cubic_numbers, truncated_octahedral_numbers,
    stella_octangula_numbers, centered_cube_numbers, rhombic_dodecahedral_numbers,
    hauy_rhombic_dodecahedral_numbers, centered_tetrahedron_numbers, centered_tetrahedral_numbers,
    centered_square_pyramid_numbers, centered_pyramid_numbers, centered_mgonal_pyramid_numbers,
    centered_octahedron_numbers, centered_icosahedron_numbers, centered_cuboctahedron_numbers,
    centered_dodecahedron_numbers, centered_truncated_tetrahedron_numbers, centered_truncated_cube_numbers,
    centered_truncated_octahedron_numbers, centered_mgonal_pyramidal_numbers, centered_hexagonal_pyramidal_numbers,
    hex_pyramidal_numbers,  hexagonal_prism_numbers, mgonal_prism_numbers, generalized_mgonal_pyramidal_numbers,
    generalized_cubic_numbers, generalized_octahedral_numbers, generalized_icosahedral_numbers,
    generalized_dodecahedral_numbers, generalized_centered_cube_numbers,
    generalized_centered_tetrahedron_numbers, generalized_centered_square_pyramid_numbers,
    generalized_rhombic_dodecahedral_numbers, generalized_centered_mgonal_pyramidal_numbers,
    generalized_mgonal_prism_numbers, generalized_hexagonal_prism_numbers
)

from .specific_space_figuratenum import (
    triangular_pyramidal_numbers, square_pyramidal_numbers, pyramidal_numbers, pentagonal_pyramidal_numbers,
    hexagonal_pyramidal_numbers, heptagonal_pyramidal_numbers, octagonal_pyramidal_numbers,
    nonagonal_pyramidal_numbers, decagonal_pyramidal_numbers, hendecagonal_pyramidal_numbers,
    dodecagonal_pyramidal_numbers, tridecagonal_pyramidal_numbers, tetradecagonal_pyramidal_numbers,
    pentadecagonal_pyramidal_numbers, hexadecagonal_pyramidal_numbers, heptadecagonal_pyramidal_numbers,
    octadecagonal_pyramidal_numbers, nonadecagonal_pyramidal_numbers, icosagonal_pyramidal_numbers,
    icosihenagonal_pyramidal_numbers, icosidigonal_pyramidal_numbers, icositrigonal_pyramidal_numbers,
    icositetragonal_pyramidal_numbers, icosipentagonal_pyramidal_numbers, icosihexagonal_pyramidal_numbers,
    icosiheptagonal_pyramidal_numbers, icosioctagonal_pyramidal_numbers,
    icosinonagonal_pyramidal_numbers, triacontagonal_pyramidal_numbers,

    triangular_tetrahedral_numbers, triangular_square_pyramidal_numbers, square_tetrahedral_numbers,
    square_square_pyramidal_numbers, tetrahedral_square_pyramidal_numbers,


    centered_pentagonal_pyramid_numbers, centered_hexagonal_pyramid_numbers,
    centered_heptagonal_pyramid_numbers, centered_octagonal_pyramid_numbers,

    centered_triangular_pyramidal_numbers, centered_square_pyramidal_numbers, centered_pentagonal_pyramidal_numbers,
    centered_heptagonal_pyramidal_numbers, centered_octagonal_pyramidal_numbers, centered_nonagonal_pyramidal_numbers,
    centered_decagonal_pyramidal_numbers, centered_hendecagonal_pyramidal_numbers, centered_dodecagonal_pyramidal_numbers
)

from .multidimensional_figuratenum import (
    pentatope_numbers, hypertetrahedral_numbers, triangulotriangular_numbers, k_hypertetrahedron_numbers,
    regular_k_polytopic_numbers, figurate_numbers_of_order_k, k_dimensional_hypertetrahedron_numbers,
    biquadratic_numbers, k_dimensional_hypercube_numbers, k_hypercube_numbers, hyperoctahedral_numbers,
    hexadecachoron_numbers, four_cross_polytope_numbers, four_orthoplex_numbers, hypericosahedral_numbers,
    tetraplex_numbers, polytetrahedron_numbers, hexacosichoron_numbers, hyperdodecahedral_numbers,
    hecatonicosachoron_numbers, dodecaplex_numbers, polydodecahedron_numbers, polyoctahedral_numbers,
    icositetrachoron_numbers, octaplex_numbers, hyperdiamond_numbers,  k_dimensional_hyperoctahedron_numbers,
    k_cross_polytope_numbers, four_dimensional_mgonal_pyramidal_numbers, mgonal_pyramidal_numbers_of_the_second_order,
    k_dimensional_mgonal_pyramidal_numbers, mgonal_pyramidal_numbers_of_the_k_2_th_order,
    centered_biquadratic_numbers, k_dimensional_centered_hypercube_numbers, centered_polytope_numbers,
    k_dimensional_centered_hypertetrahedron_numbers, centered_hyperoctahedral_numbers, orthoplex_numbers,
    nexus_numbers, k_dimensional_centered_hyperoctahedron_numbers,

    generalized_pentatope_numbers, generalized_k_dimensional_hypertetrahedron_numbers,
    generalized_biquadratic_numbers, generalized_k_dimensional_hypercube_numbers, generalized_hyperoctahedral_numbers,
    generalized_k_dimensional_hyperoctahedron_numbers, generalized_hyperdodecahedral_numbers,
    generalized_hypericosahedral_numbers, generalized_polyoctahedral_numbers,
    generalized_k_dimensional_mgonal_pyramidal_numbers, generalized_k_dimensional_centered_hypercube_numbers,
    generalized_nexus_numbers
)

from .specific_multidimensional_figuratenum import (
    five_dimensional_hypertetrahedron_numbers, six_dimensional_hypertetrahedron_numbers,

    five_dimensional_hypercube_numbers, six_dimensional_hypercube_numbers,

    four_dimensional_hyperoctahedron_numbers, five_dimensional_hyperoctahedron_numbers,
    six_dimensional_hyperoctahedron_numbers, seven_dimensional_hyperoctahedron_numbers,
    eight_dimensional_hyperoctahedron_numbers, nine_dimensional_hyperoctahedron_numbers,
    ten_dimensional_hyperoctahedron_numbers,

    four_dimensional_square_pyramidal_numbers, four_dimensional_pentagonal_pyramidal_numbers,
    four_dimensional_hexagonal_pyramidal_numbers, four_dimensional_heptagonal_pyramidal_numbers,
    four_dimensional_octagonal_pyramidal_numbers, four_dimensional_nonagonal_pyramidal_numbers,
    four_dimensional_decagonal_pyramidal_numbers, four_dimensional_hendecagonal_pyramidal_numbers,
    four_dimensional_dodecagonal_pyramidal_numbers,

    five_dimensional_mgonal_pyramidal_numbers, five_dimensional_square_pyramidal_numbers,
    five_dimensional_pentagonal_pyramidal_numbers, five_dimensional_hexagonal_pyramidal_numbers,
    five_dimensional_heptagonal_pyramidal_numbers, five_dimensional_octagonal_pyramidal_numbers,
    six_dimensional_mgonal_pyramidal_numbers, six_dimensional_square_pyramidal_numbers,
    six_dimensional_pentagonal_pyramidal_numbers, six_dimensional_hexagonal_pyramidal_numbers,
    six_dimensional_heptagonal_pyramidal_numbers, six_dimensional_octagonal_pyramidal_numbers,

    five_dimensional_centered_hypercube_numbers,
    six_dimensional_centered_hypercube_numbers,

    five_dimensional_centered_hypertetrahedron_numbers,
    six_dimensional_centered_hypertetrahedron_numbers,

    five_dimensional_centered_hyperoctahedron_numbers,
    six_dimensional_centered_hyperoctahedron_numbers
)
